### Method

# Secret Prompt perform_sync

#### Declaration [src]

    GVariant*
    secret_prompt_perform_sync (
      SecretPrompt* self,
      const gchar* window_id,
      GCancellable* cancellable,
      const GVariantType* return_type,
      GError** error
    )

#### Description [src]

Runs a prompt and performs the prompting.

Returns a variant result if the prompt was completed and not dismissed. The type of result depends on the action the prompt is completing, and is defined in the Secret Service DBus API specification.

If `window_id` is non-null then it is used as an XWindow id on Linux. The API expects this id to be converted to a string using the `%d` printf format. The Secret Service can make its prompt transient for the window with this id. In some Secret Service implementations this is not possible, so the behavior depending on this should degrade gracefully.

This method may block indefinitely and should not be used in user interface threads.

#### Parameters

`window_id`

  Type: `const gchar*`

  String form of XWindow id for parent window to be transient for.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  Optional cancellation object.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`return_type`

  Type: `GVariantType`

  The variant type of the prompt result.

  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GVariant`

`NULL` if the prompt was dismissed or an error occurred.

The caller of the method takes ownership of the data, and is responsible for freeing it.